var thisVersion = 0.9;
var baseUrl = "http://www.joy.org.au/xml/nownext.php?fromdashboardwidget=true";
var count = 1;
var programGridReq = null;
var day = -1;
var gInfoButton;
var gDoneButton;
var gDebugButton;
var doneIsDone = false;
var infoIsDone = false;
var debugIsDone = false;
var iTimer;
var fTimer;
var pTimer;
var neonCounter = 0;
var neonOpacity = 1;
var currentState = 0;
var playOpacity = 0;
var playFadeDirection = 0.04;
var getShowNamesDone = false;

function setup()
{

	var front = document.getElementById("front");
    var back = document.getElementById("back");

	front.style.display = "block";
	back.style.display = "none";

	if (!doneIsDone)
	{
		gDoneButton = new AppleGlassButton(document.getElementById("doneButton"), "Done", hidePrefs);
		doneIsDone = true;
	}

	if (!debugIsDone)
	{
		gDebugButton = new AppleGlassButton(document.getElementById("debugButton"), "Debug", toggleDebug);
		debugIsDone = true;
	}

	if (!infoIsDone)
	{
		gInfoButton = new AppleInfoButton(document.getElementById("infoButton"), document.getElementById("front"), "black", "white", showPrefs);
		gInfoButton.setStyle("black","white");
		infoIsDone = true;
	}
	
	day = new Date().getDay();
	
	toggleDebug();
	if (!getShowNamesDone)
	{
		getShowNamesDone = true;
		getShowNames();
	}
	
	if (window.widget) {
		widget.onhide = joyOnhide;
		widget.onshow = joyOnshow;
	}
	joyDebug("onhide and onshow set");
	pTimer = setInterval("pulsatePlay()", 50);

}


function toggleDebug()
{
	var debugDiv = document.getElementById("Debug");
	if (debugDiv.style.display == 'none') debugDiv.style.display = '';
	else debugDiv.style.display = 'none';

	checkNewVersion();
}

function togglePlay()
{
	if (currentState == 0) startPlaying();
	else if (currentState == 1) stopPlaying();
}

function startPlaying()
{
	neonOpacity = 1;
	var neonOverlay = document.getElementById("NeonOverlay");
	neonOverlay.style.backgroundImage = "url('neon_pink.png')";
	fTimer = setInterval("fadeNeon()", 50);
	currentState = 1;
	document.getElementById("PlayButton").setAttribute("class", "stop");
	joyDebug("Starting world radio");
	hnd_play();
	
}

function stopPlaying()
{
	neonOpacity = 1;
	var neonOverlay = document.getElementById("NeonOverlay");
	neonOverlay.style.backgroundImage = "url('neon_blue.png')";
	fTimer = setInterval("fadeNeon()", 50);
	currentState = 0;
	document.getElementById("PlayButton").setAttribute("class", "play");
	hnd_stop();
}

function cancelPlayPulsate()
{
	var playOverlay = document.getElementById("PlayButtonOverlay");
	playOverlay.style.display = 'none';
	clearInterval(pTimer);
	pTimer = null;
}

function pulsatePlay()
{
	if (currentState == 0)
	{
		var playOverlay = document.getElementById("PlayButtonOverlay");
		playOverlay.style.display = 'block';
		playOpacity = playOpacity + playFadeDirection;
		playOverlay.style.opacity = playOpacity;
		if (playOpacity <= 0 || playOpacity >= .6) playFadeDirection = -playFadeDirection;
	}
	else
	{
		var playOverlay = document.getElementById("PlayButtonOverlay");
		playOverlay.style.display = 'none';
	}
}

function fadeNeon()
{
	var neonOverlay = document.getElementById("NeonOverlay");
	if (neonOpacity > 0) neonOpacity = neonOpacity - .01;
	else fTimer = null;
	neonOverlay.style.opacity = neonOpacity;
}

function joyDebug(str)
{
	 var debugDiv = document.getElementById('Debug');
	 debugDiv.appendChild(document.createTextNode(str));
	 debugDiv.appendChild(document.createElement("br"));
	 debugDiv.scrollTop = debugDiv.scrollHeight;
}

function problemEncountered(problemDescription)
{
	hnd_stop();
	joyDebug("Problem encountered: " + problemEncountered);
	var neonOverlay = document.getElementById("NeonOverlay");
	neonOverlay.style.backgroundImage = 'none';
	clearInterval(iTimer);
	currentState = 2;
	document.getElementById("PlayButton").setAttribute("class", "problem");
}

function joyOnshow() 
{
	checkNewVersion();
	getShowNames();
}

function joyOnhide() {
}


function showPrefs() {

	var front = document.getElementById("front");
    var back = document.getElementById("back");
	
	if (window.widget)
		widget.prepareForTransition("ToBack");

	front.style.display = "none";
	back.style.display = "block";

	if (window.widget)
		setTimeout ('widget.performTransition();', 0);

}

function hidePrefs() {

	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToFront");

	back.style.display="none";
	front.style.display="block";
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);

}

function goToUrl(event, url)
{
	if (window.widget)
	{
		widget.openURL(url);
	}
}

function getShowNames()
{

	var xmlhttp = null;
	xmlhttp = new XMLHttpRequest();

	xmlhttp.open("GET", baseUrl, true);
	xmlhttp.onreadystatechange = function() 
	{

		var onAirNowDiv = document.getElementById("OnNow");
		var onAirNextDiv = document.getElementById("OnNext");

		if (xmlhttp.readyState==4)
		{

			var returnedXml = xmlhttp.responseXML;
			var programNow = returnedXml.getElementsByTagName("program")[0];
			var programNext = returnedXml.getElementsByTagName("program")[1];

			joyDebug("programNow weblink: " + programNow.getElementsByTagName("programpageurl")[0].childNodes[0].nodeValue);
			joyDebug("programNow name: " + programNow.getElementsByTagName("name")[0].childNodes[0].nodeValue);

			/*var returns = xmlhttp.responseText;
			returns = returns.replace(/[\r\n]/gim, "");

			var regEx = /<div id=\"OnAirNow\".*?>.*?<a href=\"(.*?)\"><h3>(.*?)<\/h3>.*?<div id=\"OnAirNext\"/gmi;
			var onAirNowText = regEx.exec(returns);*/
			
			if (programNow)
			{
				onAirNowDiv.innerHTML = "Now: <a href=\"#\" onclick=\"javascript:goToUrl(event, '" + programNow.getElementsByTagName("programpageurl")[0].childNodes[0].nodeValue + "');\">" + programNow.getElementsByTagName("name")[0].childNodes[0].nodeValue + "</a>";
			}
			else
			{
				onAirNowDiv.innerHTML = "On-air info unavailable";
			}
			/*var regEx = /<div id=\"OnAirNext\".*?>.*?<a href=\"(.*?)\"><h3>(.*?)<\/h3>.*?<div id=\"OnAirBottom\"/gmi;
			var onAirNextText = regEx.exec(returns);*/
			
			if (programNext)
			{
				onAirNextDiv.innerHTML = "Next: <a href=\"#\" onclick=\"javascript:goToUrl(event, '" + programNext.getElementsByTagName("programpageurl")[0].childNodes[0].nodeValue + "');\">" + programNext.getElementsByTagName("name")[0].childNodes[0].nodeValue + "</a>";
			}
			else
			{
				onAirNextDiv.innerHTML = "Next: n/a";
			}
		}
		else if (xmlhttp.readyState == 3)
		{
				onAirNowDiv.innerHTML = "(Finding on-air info...)" ;
				onAirNextDiv.innerHTML = "";
		}
		else 
		{
			onAirNowDiv.innerHTML = "On-air info unavailable";
			onAirNextDiv.innerHTML = "";
		}
	}
	xmlhttp.send();
	
	var onAirNowDiv = document.getElementById("OnNow");
	var onAirNextDiv = document.getElementById("OnNext");

	onAirNowDiv.innerHTML = "(Finding on-air info...)" ;
	onAirNextDiv.innerHTML = "";
}

function checkNewVersion()
{

	var versionIconDiv = document.getElementById("VersionIcon");
	versionIconDiv.style.display = 'none';

	var xmlhttp = null;
	xmlhttp = new XMLHttpRequest();

	xmlhttp.open("GET", baseUrl + "/widget/" + thisVersion + ".latestversion", true);
	xmlhttp.onreadystatechange = function() 
	{

		if (xmlhttp.readyState==4)
		{
			var returns = xmlhttp.responseText;
			//joyDebug(returns);
			var version = parseFloat(returns);
			if (!isNaN(version))
			{
				if (version > thisVersion) 
				{
					joyDebug("New version found.  Current version = [" + thisVersion + "].  Published version = [" + version + "]");

					if (returns.indexOf("icon\n") > 0)
					{

						var iconTextRegEx = /icontext=(.*?)\n/gmi;
						var iconTextWidthRegEx = /icontextwidth=(.*?)\n/gmi;
						var iconTextHeightRegEx = /icontextheight=(.*?)\n/gmi;
						var iconOnClickRegEx = /icononclick=(.*?)\n/gmi;

						var versionIconDiv = document.getElementById("VersionIcon");
						var versionInfoDiv = document.getElementById("VersionIconInfo");
						var infoText = "A new version of this widget is available.";
						versionIconDiv.style.display = 'block';
						versionInfoDiv.innerHTML = iconTextRegEx.exec(returns)[1];
						versionInfoDiv.style.width = iconTextWidthRegEx.exec(returns)[1];
						versionInfoDiv.style.height = iconTextHeightRegEx.exec(returns)[1];
						versionIconDiv.setAttribute("onclick", iconOnClickRegEx.exec(returns)[1]);
					}
				}
			} 

			if (returns.indexOf("backside\n") > 0)
			{
				
				joyDebug("backside to be replaced.");
				
				var backsideTextRegEx = /backsidetext=(.*?)\n/gmi;
				var backsideTextPara = document.getElementById("BacksideParagraph");
				backsideTextPara.innerHTML = backsideTextRegEx.exec(returns)[1];
				
				joyDebug("Backside text = [" + backsideTextRegEx.exec(returns)[1] + "]");
				
			}
			
		}
	
	}
	xmlhttp.send();

}
function showVersionInfo()
{
	var versionInfoDiv = document.getElementById("VersionIconInfo");
	versionInfoDiv.style.display = 'block';
}
function hideVersionInfo()
{
	joyDebug("hideVersionInfo() called.");
	var versionInfoDiv = document.getElementById("VersionIconInfo");
	joyDebug("versionInfoDiv = " + versionInfoDiv);
	versionInfoDiv.style.display = 'none';
}

function processRequest(e, requestHTML) {

	var gridHTML = requestHTML.responseText.split("<TR");
	var gridRowHTML = processGrid(gridHTML);

	var showName = extractShowName(gridRowHTML);
	var showDescription = extractDescription(gridRowHTML);
	
	programName.innerHTML = showName;
	programDescription.innerHTML = showDescription;
	
	requestHTML = null;
	
}
	
/* function extractShowName		- returns a String if successful
 *								- returns null if not successful
 *
 *		returns just the name of the show, with all other markup removed.
 */

function extractShowName(gridRowHTML) {

	var filterExpression = /<p style=\"font-size\:18px\" class=\"\w*\"\><STRONG\>(.*)\n.*<\/STRONG\>.*<\/p\>/ig; // class=[\w\"\-\:]*>([\n.]*)<\/p>
	var foundShowNameHTML = filterExpression.exec(gridRowHTML);

	if (foundShowNameHTML == null) return null;

	var foundShowName = foundShowNameHTML[1].replace(/<[^>]*>/gi, "");
	foundShowName = foundShowName.replace(/^\s+|\s+$/g, "");
	//alert(foundShowName);
	
	return foundShowName;

}

/* function extractDescription	- returns a String if successful
 *								- returns null if not successful
 *
 *		returns just the name of the show, with all other markup removed.
 */

function extractDescription(gridRowHTML) {

	gridRowHTML = gridRowHTML.replace(/\r/g, " ");
	gridRowHTML = gridRowHTML.replace(/\n/g, " ");
	gridRowHTML = gridRowHTML.replace(/\f/g, " ");

	//alert(gridRowHTML);

	var filterExpression = /<p class=\"pagetext\"\>(.*)<\/p\>/ig
	var foundDescriptionHTML = filterExpression.exec(gridRowHTML);
	
	if (foundDescriptionHTML == null) return null;

	var foundDescription = foundDescriptionHTML[1].replace(/<[^>]*>/gi, "");
	foundDescription = foundDescription.replace(/^\s+|\s+$/g, "");
	//alert(foundDescription);
	
	return foundDescription;

}

/* function processGrid	- returns a String if successful
 *						- returns null if not successful
 *
 *		returns some raw HTML that needs to subsequently processed through some more
 *		functions to retrieve the name of the show, and any summary info of the show.
 */

function processGrid(gridHTML) {

	//alert("about to split!");
	var startChecking = false;
	var gridBlockCount = 0;
	var gridBlockTimes = new Array();
	var gridBlockRowIndexes = new Array();
	var currentDate = new Date();
	var lastIndexFound = -1;
	var thisRowsColumns = null;
	
	for (i=1; i<gridHTML.length; i++) {
		
		if (gridHTML[i].indexOf(daysArray[day] + "s on JOY 94.9") != -1) {
			startChecking = true;
			//alert("Started checking");
		}
		if (gridHTML[i].indexOf("</table>") != -1) {
			startChecking = false;
			//alert("Stopped checking");
		}
		
		if (startChecking) {
			thisRowsColumns = gridHTML[i].split(/<TD/gi);
			for (j=0; j<thisRowsColumns.length; j++) {
				var foundTime = thisRowsColumns[j].search(/\d{2}\:\d{2}\s(AM|PM)/)
				if (foundTime != -1) {
					gridBlockCount++;
					gridBlockTimes[gridBlockCount] = thisRowsColumns[j].substr(foundTime, 8);
					gridBlockRowIndexes[gridBlockCount] = i;
				}
			}

		}
		

	}
	
	if (gridBlockCount == 0) {

		return null;

	} else {
	
		for (i=1; i<=gridBlockCount; i++) {
			gridBlockTimes[i] = convertTo24HourTime(gridBlockTimes[i]);
			
			var hours = extractHours(gridBlockTimes[i]);
			var	minutes = extractMinutes(gridBlockTimes[i]);
			
			if (hours < currentDate.getHours() || (hours == currentDate.getHours() && minutes <= currentDate.getMinutes())) {
				lastIndexFound = gridBlockRowIndexes[i];
			}
		}
	}
	
	if (lastIndexFound == -1) {

		return null;

	} else {
	
		return gridHTML[lastIndexFound];
		
	};

}

/* function extractHours	- returns a float if successful
 *							- returns null if not successful
 *
 *		Returns the hours portion of a "hh:mm" type string
 */

function extractHours(inputTime) {
	var hours = (inputTime.search(/\d{2}\:/) != -1) ? parseFloat(inputTime.substr(inputTime.search(/\d{2}\:/), 2)) : null;
	return hours;
}


/* function extractMinutes	- returns a float if successful
 *							- returns null if not successful
 *
 *		Returns the minutes portion of a "hh:mm" type string
 */

function extractMinutes(inputTime) {
	var minutes = (inputTime.search(/\:\d{2}/) != -1) ? parseFloat(inputTime.substr(inputTime.search(/\:\d{2}/) + 1, 2)) : null;
	return minutes;
}


/* function convertTo24Hours	- returns a String if successful
 *								- returns the inputTime if unsuccessful
 *
 *		Takes a String input of a time like "12:00 PM", and turns it into 24 hour time.
 *		If the time is 12:00 AM then it returns 00:00, if the time is 8:00 PM then it
 *		returns 20:00.
 */

function convertTo24HourTime(inputTime) {

	var returnValue = "";
	var hours = extractHours(inputTime);
	var minutes = extractMinutes(inputTime);
	var amOrPm = (inputTime.search(/(AM|PM)/) != -1) ? inputTime.substr(inputTime.search(/(AM|PM)/), 2) : null;
	
	//alert("inputTime: " + inputTime + "\nvalues found...\nhours: " + hours + "\nminutes: " +minutes + "\namOrPm: " + amOrPm);

	if (hours == null || minutes == null || amOrPm == null) {
		//alert("hours: " + hours + "\nminutes: " +minutes + "\namOrPm: " + amOrPm);
		return inputTime;
	} else {
		if (hours == 12 && amOrPm == "AM") hours = hours - 12;
		if (amOrPm == "PM" && hours != 12) hours = hours + 12;
		returnValue = ((hours.toString().length == 1) ? "0" : "") + hours + ":" + ((minutes.toString().length == 1) ? "0" : "") + minutes;
		//alert("inputTime: " + inputTime + "\nconverts to...\nhours: " + hours + "\nminutes: " +minutes + "\namOrPm: " + amOrPm + "\nresulting in: " + returnValue);
		return returnValue;
	}

}

