/*******************************************************************************
 * WRW - WorldRadio Widget
 * by Alexandre Bazyl <wrw@bazyl.com.br>
 *
 * -- version 1.3   :: JUN/2008
 * -- version 1.1.4 :: OCT/2007
 * -- version 1.1.3 :: OCT/2007
 * -- version 1.1.2 :: SEP/2007
 * -- version 1.0b  :: AUG/2007
 *
 * wrconfig.js - Eventos/funcoes de configuracao
 *
 *******************************************************************************/


/*********************************** CONFIG ************************************/

// Object Config e seus metodos
Config = new Object();
Config.save = config_cfgSave;
Config.load = config_cfgLoad;
Config.getParameters = config_getParameters;
Config.setParameters = config_setParameters;
// Atributos
Config.isChangedRadio = false;
Config.isChangedCountry = false;
Config.isChangedConfig = false;
Config.cfgVersionWidget = "1.32";
Config.cfgVersionConfig = "1.1";
Config.cfgUpdateWidget = false;
Config.cfgAutoplay = false;
Config.cfgMetadata = true;
Config.cfgAllowUpdate = true;


/*******************************************************************************
 * config_cfgSave - Salva as configuracoes nas preferencias
 *******************************************************************************/
function config_cfgSave() {
	// Recupera os parametros das checkboxes
	Config.getParameters();
	
	// Salva as configuracoes
	var strgeneral = "";
	strgeneral = Config.cfgVersionWidget + ";";
	strgeneral = strgeneral + Config.cfgVersionConfig + ";";
	strgeneral = strgeneral + Config.cfgUpdateWidget + ";";
	strgeneral = strgeneral + Config.cfgAutoplay + ";";
	strgeneral = strgeneral + Config.cfgMetadata + ";";
	strgeneral = strgeneral + Config.cfgAllowUpdate + ";";
	
	widget.setPreferenceForKey(strgeneral, "config");
}


/*******************************************************************************
 * config_cfgLoad - Carrega as configuracoes das preferencias
 *******************************************************************************/
function config_cfgLoad() {
	// Carrega as strings identificadoras
	if(window.widget)
		var cfgconfig = widget.preferenceForKey("config");
	else return;
//	alert(cfgconfig);
	// Parse das configuracoes
	if (cfgconfig > "") {
		for (var i=1; i<=5; i++) {
			var str1 = cfgconfig.substring(0, cfgconfig.indexOf(';'));
			if (str1 > "") {
				switch(i) {
					case 1:	// Versao do Widget
						//Config.cfgVersionWidget = str1;
						break;
						
					case 2:	// Versao da configuracao
						Config.cfgVersionConfig = str1;
						break;
						
					case 3:	// VRF atualizacao do Widget automaticamente
						if (str1 == "true") Config.cfgUpdateWidget = true;
						else Config.cfgUpdateWidget = false;
						break;
						
					case 4:	// Autoplay
						if (str1 == "true") Config.cfgAutoplay = true;
						else Config.cfgAutoplay = false;
						break;
						
					case 5:	// Show Metadata
						if (str1 == "true") Config.cfgMetadata = true;
						else Config.cfgMetadata = false;
						break;
						
					case 6:	// Permite atualizacao dos nomes/links das radios
						if (str1 == "true") Config.cfgAllowUpdate = true;
						else Config.cfgAllowUpdate = false;
						break;
				}
			}
			cfgconfig = cfgconfig.substring(cfgconfig.indexOf(';')+1);
		}
	}
	
	/*
		// Versao do Widget
		var str1 = cfgconfig.substring(0, cfgconfig.indexOf(';'));
		if (str1 > "")
			Config.cfgVersionWidget = str1;
		cfgconfig = cfgconfig.substring(cfgconfig.indexOf(';')+1);
		// Versao da configuracao		
		str1 = cfgconfig.substring(0, cfgconfig.indexOf(';'));
		if (str1 > "")
			Config.cfgVersionConfig = str1;
		cfgconfig = cfgconfig.substring(cfgconfig.indexOf(';')+1);
		// Update Widget automaticamente
		if (cfgconfig.substring(0, cfgconfig.indexOf(';')) == "true")
			Config.cfgUpdateWidget = true;
		cfgconfig = cfgconfig.substring(cfgconfig.indexOf(';')+1);
		// Funcao Autoplay
		if (cfgconfig.substring(0, cfgconfig.indexOf(';')) == "true")
			Config.cfgAutoplay = true;
	*/
//		alert("Load = WID=" + Config.cfgVersionWidget + ", CFG=" + Config.cfgVersionConfig + ", UPD=" + Config.cfgUpdateWidget + ", PLA=" + Config.cfgAutoplay + ",MET=" + Config.cfgMetadata + ",ALW=" + Config.cfgAllowUpdate);
	//}
}


/*******************************************************************************
 * config_getParameters - Recupera as configuracoes selecionadas nas
 *                       checkbox (no frame Config)
 *******************************************************************************/
function config_getParameters()
{
	Config.cfgAutoplay = document.getElementById("chk_config_autoplay").checked;
	Config.cfgMetadata = document.getElementById("chk_config_metadata").checked;
	Config.cfgUpdateWidget = document.getElementById("chk_config_updatewidget").checked;
	Config.cfgAllowUpdate = document.getElementById("chk_config_allowupdate").checked;
}


/*******************************************************************************
 * config_setParameters - Define as configuracoes para as checkbox 
 *                        (no frame Config)
 *******************************************************************************/
function config_setParameters()
{
	document.getElementById("chk_config_autoplay").checked = Config.cfgAutoplay;
	document.getElementById("chk_config_metadata").checked = Config.cfgMetadata;
	document.getElementById("chk_config_updatewidget").checked = Config.cfgUpdateWidget;
	document.getElementById("chk_config_allowupdate").checked = Config.cfgAllowUpdate;
}
