/*******************************************************************************
 * WRW - WorldRadio Widget
 * by Alexandre Bazyl <wrw@bazyl.com.br>
 *
 * -- version 1.3   :: JUN/2008
 * -- version 1.1.4 :: OCT/2007
 * -- version 1.1.3 :: OCT/2007
 * -- version 1.1.2 :: SEP/2007
 * -- version 1.0b  :: AUG/2007
 *
 * wrpanel.js - funcoes relacionadas aos paineis
 *
 *******************************************************************************/
 
 
/************************************ PANEL ************************************/

Panel = new Object();
Panel.backHide = panel_hideBack;
Panel.backShow = panel_showBack;
Panel.backShowMessage = panel_displayMessage;
Panel.frontHide = panel_hideFront;
Panel.frontShow = panel_showFront;
Panel.showStatusMessage = panel_showStatusMessage;
Panel.hideStatusMessage = panel_hideStatusMessage;
Panel.setStatusMessage = panel_setStatusMessage;

Panel.statusMessage = "";
Panel.statusTime = 0;
Panel.statusState = 0;

/********************************** BACK FRAME **********************************/

Frame = new Object();
Frame.show = frame_change;


/********************************* PANEL-BACK **********************************/

/*******************************************************************************
 * panel_hideBack - Oculta o painel de mensagens (message_box - back).
 *******************************************************************************/
function panel_hideBack() {
	document.getElementById("message_txt").style.display = "none";
	document.getElementById("message_box").style.display = "none";
}


/*******************************************************************************
 * panel_showBack - Exibe o painel de mensagens (message_box - back).
 *******************************************************************************/
function panel_showBack() {
	document.getElementById("message_txt").style.display = "block";
	document.getElementById("message_box").style.display = "block";
}


/*******************************************************************************
 * panel_displayMessage - Exibe uma mensagem no paine de mensagens durante 3seg.
 * Entrada: msg: mensagem a ser exibida
 *******************************************************************************/
function panel_displayMessage(msg)
{
	document.getElementById("message_txt").innerHTML = msg;
	Panel.backShow();
	setTimeout("Panel.backHide()", 3000);
}


/********************************* PANEL-FRONT *********************************/

/*******************************************************************************
 * panel_hideFront - Oculta o painel de informacoes (info_box) e os frames
 *                   'frame_updatecfg' e 'frame_info'
 *******************************************************************************/
function panel_hideFront() {
	// Oculta o painel
	//document.getElementById("info_box").style.display = "none";
	document.getElementById("update_box").style.display = "none";
	// Oculta o frame_updatecfg
	document.getElementById("frame_updatecfg").style.visibility = "hidden";
	// Oculta o frame_info
	//document.getElementById("frame_info").style.visibility = "hidden";
	// Volta o info para a posicao default (alterado pela funcao de atualizar radios)
	//document.getElementById("info_lbl").style.top = "5px";
	
	// Habilita a exibicao dos botoes (yes/no/ok)
	document.getElementById("btn_no").style.display = "block";
	document.getElementById("btn_yes").style.display = "block";
	document.getElementById("btn_ok").style.display = "block";
}


/*******************************************************************************
 * panel_showFront - Exibe o painel de informacoes (info_box) e o frame apontado
 *                   por 'frame' ('updatecfg' ou 'info')
 *******************************************************************************/
function panel_showFront(button) {
	// Exibe o painel
	document.getElementById("update_box").style.visibility = "visible";
	document.getElementById("update_box").style.display = "block";
	// Exibe os botoes correspondentes
	if (button=="yesno") {
		var fbtn_yesno = "block";
		var fbtn_ok = "none";
	}
	else if (button=="ok") {
		var fbtn_yesno = "none";
		var fbtn_ok = "block";
	}

	// Exibe/Oculta os botoes yes/no
	document.getElementById("btn_no").style.display = fbtn_yesno;
	document.getElementById("btn_yes").style.display = fbtn_yesno;

	// Exibe/Ocutal o botao ok
	document.getElementById("btn_ok").style.display = fbtn_ok;

	// Exibe o frame
	document.getElementById("frame_updatecfg").style.visibility = "visible";
	document.getElementById("frame_updatecfg").style.display = "block";
}


/********************************** BACK FRAME **********************************/

/*******************************************************************************
 * frame_change - Exibe o frame apontado por "rdxshow", oculta os demais frames
 *                e atualiza os icones das abas.
 * Entrada: rdxshow - valores permitidos: "radio", "country", "config" e "update"
 *******************************************************************************/
function frame_change(rdxshow) {
	var frames = Array;
	frames[0]="radio";
	frames[1]="country";
	frames[2]="config";
	frames[3]="update";
	
	for (var i=0; i<=3; i++) {
		// Oculta o frame 'hide'
		var hide = "frame_" + frames[i];
		document.getElementById(hide).style.visibility = "hidden";
		hide = "aba_" + frames[i] + "_lbl";
		document.getElementById(hide).style.color = "#909090"; //"#646464";
	}
	var show = "frame_" + rdxshow;
	var abashow = "aba_" + rdxshow + "_lbl";
		
	// Exibe o frame 'show'
	document.getElementById(show).style.display = "block";
	document.getElementById(show).style.visibility = "visible";
	
	// Atualiza a cor da aba
	document.getElementById(abashow).style.color = "#000000"; //FFFFFF";
}


function panel_setStatusMessage(msg, scrolling, color1) {
	Panel.statusMessage = msg;
	
	if (Panel.statusTime)
		clearTimeout(Panel.statusTime);
	
	if (scrolling) Panel.statusState = 1;
	else Panel.statusState = 0;
	
	if (color1=="default") document.getElementById("media_status").style.color = "#C96600";
	else if(color1=="bold") document.getElementById("media_status").style.color = "#00BF00";
}


function panel_showStatusMessage() {
	document.getElementById("media_status").innerHTML = "";
	document.getElementById("media_status").style.visibility = "visible";
	document.getElementById("media_status").style.display = "block";
	var pontos = "";
	
	// Messagem com scroll dos pontos (. .. ...)
	if (Panel.statusState > 0) {
		if (Panel.statusState == 1) pontos=".";
		else if (Panel.statusState == 2) pontos="..";
		else if (Panel.statusState == 3) pontos="...";

		Panel.statusState++;
		if (Panel.statusState > 3)
			Panel.statusState=1;
			
		Panel.statusTime = setTimeout("Panel.showStatusMessage()", 500);
	}
	//else Panel.statusTime = setTimeout("Panel.hideStatusMessage()", 4000);
	
	document.getElementById("media_status").innerHTML = Panel.statusMessage + pontos;
}

function panel_hideStatusMessage() {
	//document.getElementById("media_status").style.display = "block";
	document.getElementById("media_status").innerHTML = "";
	if (Panel.statusTime)
		clearTimeout(Panel.statusTime);
	Panel.statusState = 0;
	document.getElementById("media_status").style.color = "#C96600";
}
