/*******************************************************************************
 * WRW - WorldRadio Widget
 * by Alexandre Bazyl <wrw@bazyl.com.br>
 *
 * -- version 1.3   :: JUN/2008
 * -- version 1.1.4 :: OCT/2007
 * -- version 1.1.3 :: OCT/2007
 * -- version 1.1.2 :: SEP/2007
 * -- version 1.0b  :: AUG/2007
 *
 * wrplayer.js - Eventos/funcoes do form principal (player)
 *
 *******************************************************************************/

// Objeto Volume e seus metodos
Volume = new Object();
Volume.inc = volume_inc;
Volume.dec = volume_dec;
Volume.hidePanel = volume_hidePanel;
Volume.showPanel = volume_showPanel;
Volume.refreshButtons = volume_refreshButtons;
// Atributos de Volume
Volume.visiblePanel = false;
Volume.timePanel = 0;
Volume.level = 50;
Volume.kapa = 1;

// Objeto Display e seus metodos
Display = new Object();
Display.showCodec = display_showCodec;
Display.hideCodec = display_hideCodec;
Display.startScroll = display_startScroll;
Display.scrollStatus = display_scrollStatus;
Display.hideMediaName = display_hideMediaName;
Display.hideMediaStatus = display_hideMediaStatus;
Display.changeScroll = display_changeScroll;
// Atributos
Display.stringScroll;			// str_scroll;
Display.stringScrollOriginal;	// str_scroll_original;
Display.timeScroll;				// tmScroll;
Display.msgScroll;
Display.stringScrollMetadata;

// Objeto Streaming e seus metodos
Streaming = new Object();
Streaming.play = streaming_play;
Streaming.stop = streaming_stop;
Streaming.createPlayer = streaming_createPlayer;
//Streaming.onBuffering = streaming_onBuffering;
//Streaming.onPlayStateChange = streaming_onPlayStateChange;
//Streaming.onErrorMessage = streaming_onErrorMessage;
Streaming.getMediaPlayerStatus = streaming_getMediaPlayerStatus;
Streaming.detectPlugin = streaming_detectPlugin;
// Atributos
Streaming.rebuffering = false;
Streaming.errorCounter = 0;
Streaming.timeStatus = 0;
Streaming.connectionStep = 0;
Streaming.isPlaying = false;
Streaming.radio = 0;	// radioplaying

// Controle da radio que esta tocando / conectando
//var isPlaying = false;
//var radioplaying=0;


/*********************************** PLAYER ************************************/

/*******************************************************************************
 * playradio - button "Play". Recupera as informacoes da radio selecionada,
 *             atualiza as informacoes no display e chama a funcao play.
 *			   Se existir eventos em andamento de alguma radio sendo tocada,
 *             entao pára esses eventos.
 *******************************************************************************/
function streaming_play() {

	// Se existe alguma radio tocando entao pára
	if (Streaming.isPlaying || (document.getElementById("MediaPlayer")!=null)) {
		//document.getElementById("btn_play").src = "Images/play2.png";
		Streaming.stop();
	}
	// Se existe algum scroll entao pára
	//if (Display.timeScroll)
	//	clearTimeout(Display.timeScroll);
	// Se existe alguma conexao em andamento, pára a exibicao do status
	//if (Streaming.timeStatus)
	//	clearTimeout(Streaming.timeStatus);
	
	//Display.hideMediaName();
			
//	var box = document.getElementById("popup_plRadio");
//	if (box.length == 0) return;
	
	// Recupera as informacoes da radio (numero, link e codec)
	//var numradio = box.options[box.selectedIndex].value;
	//Streaming.radio = numradio;
	var radiolink = "http://media.on.net/radio/62.pls";
	var radiocodec = "mp3";
	
	// Define a string com o nome da radio e do pais para o scroll
	//Display.stringScroll = "JOY Radio";
	//Display.stringScrollOriginal = Display.stringScroll;
	//Display.stringScrollMetadata = "";
	//Display.msgScroll = 1;		// Usa o Display.stringScrollOriginal
	
	// Exibe o codec utilizado
	//Display.showCodec(numradio);
	
	// Ajusta o mime/fator multiplicador do volume de acordo com o codec
	var codec="";
	var protocol=radiolink.substring(0,4);

	joyDebug("figuring out codec");
	
	if (radiocodec == "wmp") {
		//if(protocol=="mms:")
		//	codec="audio/mpeg";
		//else
		//	codec="video/x-ms-asf";
		//codec="audio/x-ms-wma";
		codec="audio/mpeg";
		Volume.kapa=2;
	}
	else if (radiocodec == "mp3") {
		Volume.kapa=1;
		var pos=radiolink.length;
		pos=pos-4;
		if (radiolink.lastIndexOf(".m3u") == pos) {
			codec="audio/x-pn-realaudio-plugin";	// MP3 (m3u)
		}
		else {
			//codec="audio/x-pn-realaudio-plugin";	// MP3 (pls)
			codec="audio/mpeg";
		}
		Volume.kapa=1;
	}
	else if (radiocodec == "real") {
		codec="audio/x-realaudio";					// Real (rm, ram)
		Volume.kapa=1;
	}

	//if (radiolink.substring(0,4) == "mms:")
	//	codec="application/x-mplayer2";

	joyDebug("setting up createPlayer timeout");
	
	Streaming.isPlaying = true;
	Streaming.rebuffering=false;
	Streaming.errorCounter=0;

	// Exibe a string media_status
	//document.getElementById("media_status").innerHTML = "";
	// Ajusta o icone do botao de play
	//document.getElementById("btn_play").src = "Images/play2act.png";
	// Habilita os botoes de volume
	Volume.refreshButtons("enable");
	// Exibe a string media_status
	//document.getElementById("media_status").innerHTML = "Contacting...";
	
	// Inicia o player
	var str1 = "Streaming.createPlayer(\"" + radiolink + "\" , \"" + codec + "\")";
	setTimeout(str1, 500);
}


/*******************************************************************************
 * play - Cria o objeto embed colocando a radio para tocar e exibe o painel
 *        de conexao (media_box).
 * Entrada: radiolink - URL da radio
 *            apptype - string contendo o codec a ser utilizado
 *******************************************************************************/
function streaming_createPlayer(radiolink, apptype)
{
	var wplayer = document.createElement('embed');
	wplayer.setAttribute("id","MediaPlayer");
	wplayer.setAttribute("EnableJavaScript","true");
	wplayer.setAttribute("width","1");
	wplayer.setAttribute("height","1");
	wplayer.setAttribute("src", radiolink);
	wplayer.setAttribute("type", apptype);
	wplayer.setAttribute("controller","false");
	wplayer.setAttribute("autostart","true");
	wplayer.setAttribute("buffer", "5000");
	wplayer.setAttribute("volume", Volume.level * Volume.kapa);
	
	// Funcoes de callback para radios em RM (mostrarao o status da conexao no painel de conexao)
	if (apptype == "audio/x-realaudio" || apptype=="audio/x-pn-realaudio-plugin") {
		wplayer.setAttribute("scriptcallbacks", "OnBuffering(), OnPlayStateChange(), OnErrorMessage()");
	}
			

	// Se jah existe um player ativo, remove-o
	if (document.getElementById("MediaPlayer") != null)
		document.getElementById("body").removeChild(document.getElementById("MediaPlayer"));	
	// Ativa o player

	joyDebug("Appending child wplayer - " + radiolink + ": " + apptype);

	document.getElementById("body").appendChild(wplayer);

	// Desabilita o botao Info enquanto conecta
	//document.getElementById("info").style.display="none";
	
	joyDebug("wplayer status: " + document.getElementById("MediaPlayer").type);

	// Como as radios MP3/WMP nao possuem funcoes de callback, pegaremos o status a cada 1s.
	if (apptype == "audio/mpeg") {
	//if (apptype == "audio/x-ms-wma") {
		Streaming.connectionStep=1;
		Streaming.getMediaPlayerStatus();
	}
}


/*******************************************************************************
 * stopradio - Pára o player e ajusta as informacoes do display
 *******************************************************************************/
function streaming_stop()
{
	if (Streaming.isPlaying || (document.getElementById("MediaPlayer")!=null)) {
//		document.getElementById("btn_play").src = "Images/play2.png";
	
		// Stop
		if (document.getElementById("MediaPlayer")!=null) {
			var ctype = document.getElementById("MediaPlayer").getAttribute("type");
			if (ctype == "audio/mpeg")
			//if (ctype == "audio/x-ms-wma")
				document.getElementById("MediaPlayer").Stop();
			else
				document.getElementById("MediaPlayer").DoStop();
		}

		// Remove Objeto
		document.getElementById("body").removeChild(document.getElementById("MediaPlayer"));

		// Pára o scroll/informacao da conexao e Oculta a string media_status
		clearTimeout(Display.timeScroll);
		clearTimeout(Streaming.timeStatus);
		//document.getElementById("media_status").innerHTML = "";
		
		//document.getElementById("media_name").innerHTML = "Stopped";
		Display.timeScroll = setTimeout("Display.hideMediaName()", 1500);
		
		Streaming.radio=0;
		// Habilita o botao Info
		//document.getElementById("info").style.display="block";
		// Oculta o codec
		Display.hideCodec();
		// Desabilita os botoes de volume
		Volume.refreshButtons("disable");
	}
	Streaming.isPlaying=false;
}


/****************************** MEDIA STATUS/INFO ******************************/

/*******************************************************************************
 * OnBuffering - Evento gerado pelas radios no formato RealMedia.
 *               Exibe a porcentagem do andamento do buffering.
 *******************************************************************************/
function OnBuffering(flag, percent) {
	if (widget_hide) {
		document.getElementById("MediaPlayer").SetAutoGoToURL(true);
		document.getElementById("MediaPlayer").SetAutoStart(true);

		if (document.getElementById("MediaPlayer").CanPlay())
			document.getElementById("MediaPlayer").DoPlay();
		//return;
	}
	
	var msg = "Buffering [" + percent + "%]";
	Panel.setStatusMessage(msg, false, "default");
	Panel.showStatusMessage();
	
	//msg = document.getElementById("media_status");
	//msg.innerHTML = "Buffering [" + percent + "%]";
}


/*******************************************************************************
 * OnPlayStateChange - Evento gerado pelas radios no formato RealMedia.
 *                     Exibe mensagem com o status da conexao com a radio.
 *******************************************************************************/
function OnPlayStateChange(old_state, state) {
	//if(widget_hide) return;
	
	//msg = document.getElementById("media_status");
	var status;

	switch(state) {
		case 0:		// Stopped
		{	
			status = "Stopped";
			break;
		}
		case 1:		// Contacting
		{
			status = "Contacting..."; 
			break;
		}
		case 2:		// Buffering
		{
			if (old_state==3)
				Streaming.rebuffering=true;
			status = "Buffering...";
			break;
		}
		case 3:		// Playing
		{
			status = "Playing...";
			if (!Streaming.rebuffering) {
				// Habilita o botao Info
				document.getElementById("info").style.display="block";
				
				// Seta o volume inicial
				var wplayer = document.getElementById("MediaPlayer");
				if (wplayer)
					wplayer.SetVolume(Volume.level * Volume.kapa);
				
				// Verifica metadata
				var author = wplayer.GetAuthor();
				var title = wplayer.GetTitle();
				var cpright = wplayer.GetCopyright();
				
				author=Parser.correctString(author);
				title=Parser.correctString(title);
				cpright=Parser.correctString(cpright);
				
				if (author.length>2 || title.length>2) {
					var useauthor = true;
					var usetitle = true;
					var virgula=false;
					
					if (author.length>2 && title.indexOf(author)>=0)
						useauthor=false;
					else if (title.length>2 && author.indexOf(title)>=0)
						usetitle=false;
					
					Display.stringScrollMetadata="";
					if (usetitle && title.length>2) {
						Display.stringScrollMetadata = title;
						virgula=true;
					}
					if (useauthor && author.length>2) {
						if (virgula) var sep=" :: ";
						else sep="";
						Display.stringScrollMetadata = Display.stringScrollMetadata + sep + author;
						virgula=true;
					}
					if (cpright.length>2 && (usetitle || useauthor))
						Display.stringScroll = Display.stringScrollMetadata + " :: " + cpright;
					
					// Usa as informacoes de metadata como scroll inicial
					//Display.stringScroll = Display.stringScrollMetadata;
					Display.msgScroll = 2;
				}
				else Display.stringScrollMetadata="";
				
				// Verifica se inicia o scroll com stringScrollOriginal ou stringScrollMetadata
				if(Config.cfgMetadata) {
					Display.stringScroll = Display.stringScrollMetadata;
					Display.msgScroll = 2;
				}
				else {
					Display.stringScroll = Display.stringScrollOriginal;
					Display.msgScroll = 1;
				}
				
				/////
//				alert("AUTHOR="+wplayer.GetAuthor()+"("+author.length+")");
//				alert("TITLE="+wplayer.GetTitle()+"("+title.length+")");
//				alert("CopyRight="+wplayer.GetCopyright());
				
				// Inicia o scroll com o nome da radio
				//Display.timeScroll = setTimeout("Display.startScroll()", 1000);
			}
			else {
				//setTimeout("Display.hideMediaStatus()", 2000);
			}
			break;
		}
		case 4:		// Seeking
		{
			status = "Seeking...";
			break;
		}
		default:
			status = "";
	}
	//msg.innerHTML = status;
	//Panel.setStatusMessage(status, false, "default");
	//Panel.showStatusMessage();
}


/*******************************************************************************
 * OnErrorMessage - Evento gerado pelas radios no formato RealMedia.
 *                  Exibe uma mensagem de erro caso a radio selecionada nao
 *                  possa ser aberta.
 *******************************************************************************/
function OnErrorMessage() {
	//msg = document.getElementById("media_status");
	//msg.innerHTML = "Error opening...";
	var msg = "Error opening...";
	Panel.setStatusMessage(msg, false, "default");
	Panel.showStatusMessage();
}


/*******************************************************************************
 * get_mpStatus - Captura e exibe o status da conexao com a radio (para os
 *			      demais formatos - MP3/WMP).
 *******************************************************************************/
function streaming_getMediaPlayerStatus() {
	// ”Waiting” — waiting for the movie data stream to begin
	// ”Loading” — data stream has begun, not able to play/display the movie yet
	// ”Playable” — movie is playable, although not all data has been downloaded
	// ”Complete” — all data has been downloaded
	// ”Error: <error number>” — the movie failed with the specified error number

	var str_status;
	var tohide = false;
	
	var msg = document.getElementById("media_status");
	var wplayer = document.getElementById("MediaPlayer");

	if (!wplayer)
	{
		joyDebug("wplayer not initialised");
	}
	else
	{
		//joyDebug("wplayer initialised");
	}

	try {
		status = wplayer.GetPluginStatus();			// Recupera o status do plugin
		joyDebug("wplayer status = " + status);
	} catch(err) {

		//joyDebug("Error " + Streaming.errorCounter + " caught: " + err);

		if(Streaming.errorCounter<20) {
			//msg.innerHTML = "Contacting2...";
			Streaming.errorCounter++;
			//Streaming.timeStatus = setTimeout("Streaming.getMediaPlayer()", 1000);
			Streaming.timeStatus = setTimeout("streaming_getMediaPlayerStatus()", 1000);
		}
		else {
			//msg.innerHTML = "Can't connect to server!";
			problemEncountered('Can\'t connect to server');
			//clearTimeout(Streaming.timeStatus);
			//setTimeout("Streaming.stop()", 3000);		// Pára o player em 3s em caso de erro
		}
		return;
	}


	// Decode da mensagem de status
	if (status.substring(0,7) == "Waiting") {
		var strpto = "";
		for(var i=1; i<=Streaming.connectionStep; i++)
			strpto = strpto + ".";
		str_status = "Connecting" + strpto;
		Streaming.connectionStep++;
		if (Streaming.connectionStep > 3) Streaming.connectionStep=1;
	}
	else if (status.substring(0,7) == "Loading")
		str_status = "Loading...";
	else if (status.substring(0,8) == "Playable") {
		str_status = "Playing..."; Streaming.errorCounter=0; tohide=true; 
		clearInterval(iTimer);
		iTimer = setInterval("incrementNeon()", 5000);

	}
	else if (status.substring(0,8) == "Complete") {
		str_status = "Playing..."; Streaming.errorCounter=0; tohide=true; 
		clearInterval(iTimer);
		iTimer = setInterval("incrementNeon()", 5000);
	}
	else if (status.substring(0,5) == "Error") {
		if (status.substring(0,9) == "Error: -1")
			str_status = "Error: media not found!";
		else str_status = status;
		
		Streaming.errorCounter=-1;
		tohide = true; 
	}
	else str_status=status;
	//msg.innerHTML = str_status;

	if (tohide) {
		// Habilita o botao Info
		//document.getElementById("info").style.display="block";
		
		// Seta o volume inicial
		var wplayer = document.getElementById("MediaPlayer");
		if (wplayer)
			wplayer.SetVolume(Volume.level * Volume.kapa);
		
		/////
//		alert("");
//		alert("Movie_Name="+wplayer.GetMovieName()+" Movie_Name(1)="+wplayer.GetMovieName(1));
//		alert("Track_Name="+wplayer.GetTrackName()+" Track_Name(1)="+wplayer.GetTrackName(1));
//		alert("TrackCount="+wplayer.GetTrackCount());
//		alert("NAM="+wplayer.GetUserData('©nam') + " :: INF=" + wplayer.GetUserData('©inf'));
//		alert("CPY="+wplayer.GetUserData('©cpy') + " :: SRC=" + wplayer.GetUserData('©src'));
//		alert("DIR="+wplayer.GetUserData('©dir') +" :: PRF="+wplayer.GetUserData('©prf'));
//		alert("PRD="+wplayer.GetUserData('©prd') +" :: WRT="+wplayer.GetUserData('©wrt'));
//		alert("QT="+wplayer.GetQuickTimeVersion());
//		alert("gTitle="+wplayer.getAttribute("Title"));
//		alert("gName="+wplayer.getAttribute("name"));
//		alert("gAuthor="+wplayer.getAttribute("AUTHOR"));
//		alert("gCopy="+wplayer.getAttribute("COPYRIGHT"));
//		alert("icy-metaint="+wplayer.getAttribute("icy-metaint"));
//		alert("icy-url="+wplayer.getAttribute("icy-url"));
//		alert(wplayer);
//		alert(".id3.title="+wplayer.title);
//		alert(".id3.author="+wplayer.author);


		///////
				
		// Verifica metadata
		var cont=0;
		Display.stringScrollMetadata="";
		
		cont=Parser.validateMetadata(wplayer.GetTrackName(), cont);
		cont=Parser.validateMetadata(wplayer.GetTrackName(), cont);
		cont=Parser.validateMetadata(wplayer.GetUserData('©nam'), cont);
		cont=Parser.validateMetadata(wplayer.GetUserData('©cpy'), cont);
		cont=Parser.validateMetadata(wplayer.GetUserData('©inf'), cont);
		cont=Parser.validateMetadata(wplayer.GetUserData('©src'), cont);
		cont=Parser.validateMetadata(wplayer.GetUserData('©dir'), cont);
		cont=Parser.validateMetadata(wplayer.GetUserData('©prf'), cont);
		cont=Parser.validateMetadata(wplayer.GetUserData('©prd'), cont);
		cont=Parser.validateMetadata(wplayer.GetUserData('©wrt'), cont);
		
//		alert("STR="+Display.stringScrollMetadata + " CONT="+cont);
		// Usa as informacoes de metadata como scroll inicial
		/*if (cont>0 && Config.cfgMetadata) {
			Display.stringScroll = Display.stringScrollMetadata;
			Display.msgScroll = 2;
		}
		else {
			Display.stringScroll = Display.stringScrollOriginal;
			Display.msgScroll = 1;
		}*/
		
		// Inicia o scroll com o nome da radio
		//Display.timeScroll = setTimeout("Display.startScroll()", 1000);
		
		// Inicia Scroll
		//if (Streaming.errorCounter==0)
		//	setTimeout("Display.startScroll()", 1000);
	}
	else {
		// Exibe o status novamente em 1s
		Streaming.timeStatus = setTimeout("Streaming.getMediaPlayerStatus()", 1000);	
	}
	
	// Em caso de erro, pára o player	
	if (status.substring(0,5) == "Error" || Streaming.errorCounter==-1) {
		clearTimeout(Streaming.timeStatus);
		setTimeout("Streaming.stop()", 3000);					// Pára o player em 3s
	}
}


function streaming_detectPlugin(plugin_name) {
	if (navigator.plugins && navigator.plugins.length > 0) {
		var pluginsArrayLength = navigator.plugins.length;
		for (var i=0; i<pluginsArrayLength; i++ ) {
			//alert("Name="+navigator.plugins[i].name);
			//alert("Desc="+navigator.plugins[i].description);
			if(navigator.plugins[i].name.indexOf(plugin_name) >= 0) {
				// || (navigator.plugins[i].description.indexOf(plugin_name) >= 0) ) {
				return(true);
			}
		}
    }
    return(false);
}


/************************************ VOLUME ***********************************/

/*******************************************************************************
 * volume_inc - Button 'incvolume'. Aumenta o volume em 10, atualiza a
 *              barra vertical de volume e mostra o painel.
 *******************************************************************************/
function volume_inc()
{
	var player = document.getElementById("MediaPlayer");
	if (!player) return;
	
	Volume.level = Volume.level + 10;
	if (Volume.level>100) Volume.level=100;

	if (!Volume.visiblePanel)			// Se painel nao estiver aberto, entao abre
		Volume.showPanel();
	else								// Painel do volume jah estah aberto
		clearTimeout(Volume.timePanel);	// entao, cancela o contador (para reiniciar depois)
		
	if (player != null) {
		// Seta o novo volume
		player.SetVolume(Volume.level * Volume.kapa);
		// Atualiza a apresentacao na barra vertical
		var volbar = document.getElementById("volume_bar");
		volbar.object.setValue(Math.abs(Volume.level));
	}
	// Oculta o painel em 2s
	Volume.timePanel = setTimeout("Volume.hidePanel()", 2000);
}


/*******************************************************************************
 * volume_dec - Button 'decvolume'. Diminui o volume em 10, atualiza a
 *			    barra vertical de volume e mostra o painel.
 *******************************************************************************/
function volume_dec()
{
	var player = document.getElementById("MediaPlayer");
	if (!player) return;
	
	Volume.level = Volume.level - 10;
	if (Volume.level<0) Volume.level=0;

	if (!Volume.visiblePanel)			// Se painel nao estiver aberto, entao abre
		Volume.showPanel();
	else								// Painel do volume jah estah aberto
		clearTimeout(Volume.timePanel);	// entao, cancela o contador (para reiniciar depois)
	
	if (player != null) {
		// Seta o novo volume
		player.SetVolume(Volume.level * Volume.kapa);
		// Atualiza a apresentacao na barra vertical
		var volbar = document.getElementById("volume_bar");
		volbar.object.setValue(Math.abs(Volume.level));
	}
	// Oculta o painel em 2s
	Volume.timePanel = setTimeout("Volume.hidePanel()", 2000);
}


/*******************************************************************************
 * volume_hidePanel - Oculta o painel de volume (volume_box).
 *******************************************************************************/
function volume_hidePanel() {
	document.getElementById("volume_bar").style.display = "none";
	document.getElementById("volume_box").style.display = "none";
	Volume.visiblePanel = false;
}


/*******************************************************************************
 * volume_showPanel - Exibe o painel de volume (volume_box).
 *******************************************************************************/
function volume_showPanel() {
	document.getElementById("volume_bar").style.display = "block";
	document.getElementById("volume_box").style.display = "block";
	Volume.visiblePanel = true;
}


/*******************************************************************************
 * volume_refreshButtons - Atualiza as imagens dos botoes de volume
 * Entrada - status: se 'enable' mostra os icones laranjas (habilitado), caso
 *                   contrario exibe os icones cinza (desabilitado)
 *******************************************************************************/
function volume_refreshButtons(status)
{
	if (status=="enable") {
//		document.getElementById("btn_incvolume").src = "images/btn_volumeinc.png";
//		document.getElementById("btn_decvolume").src = "images/btn_volumedec.png";
	}
	else {
//		document.getElementById("btn_incvolume").src = "images/btn_disvolumeinc.png";
//		document.getElementById("btn_decvolume").src = "images/btn_disvolumedec.png";
	}
}


/********************************* DISPLAY CODEC *******************************/

/*******************************************************************************
 * display_showCodec - Destaca (em verde claro) o nome do codec da radio que 
 *					   está tocando se o respectivo plugin estiver instalado.
 *					   Caso contrário, a cor não será alterada (continuará em
 *					   vermelho).
 * Entrada - numradio: número da radio que está tocando
 *******************************************************************************/
function display_showCodec(numradio)
{
	Display.hideCodec();
	// Valores de codec = "mp3", "real", "wmp"
	var codec = Radio.getAttrib(numradio, "codec");
/* Original
	if (codec=="wmp" && Streaming.detectPlugin("Windows Media")) 
		document.getElementById("lbl_codec_wmp").style.color = "#00BF00";
	else if (codec=="mp3" && Streaming.detectPlugin("QuickTime Plug-in")) 
		document.getElementById("lbl_codec_mp3").style.color = "#00BF00";
	else if (codec=="real" && Streaming.detectPlugin("RealPlayer"))
		document.getElementById("lbl_codec_real").style.color = "#00BF00";
*/
	// Versão Beta
	if (codec=="wmp" && Streaming.detectPlugin("QuickTime Plug-in") && 
						Streaming.detectPlugin("Flip4Mac Windows Media")) 
		document.getElementById("lbl_codec_wmp").style.color = "#00BF00";
	else if (codec=="mp3" && Streaming.detectPlugin("RealPlayer")) 
		document.getElementById("lbl_codec_mp3").style.color = "#00BF00";
	else if (codec=="real" && Streaming.detectPlugin("RealPlayer"))
		document.getElementById("lbl_codec_real").style.color = "#00BF00";
}


/*******************************************************************************
 * display_hideCodec - Oculta (em verde escuro) todos os nomes de codec se o
 *					   respectivo plugin estiver instalado. Caso contrario, o
 *					   nome do codec ficara em vermelho.
 *******************************************************************************/
function display_hideCodec()
{
	var colorWM = "#001F00";
	var colorQT = "#001F00";
	var colorRP = "#001F00";
/* Original
	if(!Streaming.detectPlugin("Windows Media")) colorWM = "#BF0000";
	if(!Streaming.detectPlugin("QuickTime Plug-in")) colorQT = "#BF0000";
	if(!Streaming.detectPlugin("RealPlayer")) colorRP = "#BF0000";
*/
	// Beta version
	if(!Streaming.detectPlugin("QuickTime Plug-in") || 
	   !Streaming.detectPlugin("Flip4Mac Windows Media")) colorWM = "#BF0000";
	if(!Streaming.detectPlugin("RealPlayer")) colorQT = "#BF0000";
	if(!Streaming.detectPlugin("RealPlayer")) colorRP = "#BF0000";
	
	//document.getElementById("lbl_codec_wmp").style.color = colorWM;
	//document.getElementById("lbl_codec_mp3").style.color = colorQT;
	//document.getElementById("lbl_codec_real").style.color = colorRP;
}


/***************************** SCROLL RADIO NAME *******************************/

/*******************************************************************************
 * display_startScroll - Prepara a area do player para exibir o nome da radio e
 *                       inicia o scroll
 *******************************************************************************/
function display_startScroll()
{
	if(Display.timeScroll)
		clearTimeout(Display.timeScroll);
	document.getElementById("media_status").innerHTML = "";
	document.getElementById("media_name").innerHTML = "";
	document.getElementById("media_name").style.display="block";
	// Inicia Scroll
	Display.timeScroll = setTimeout("Display.scrollStatus(13)",500);
}


/*******************************************************************************
 * display_scrollStatus - Scroll o nome da radio
 * Entrada - numspc: numero de espacos que deve ter antes do nome da radio
 *******************************************************************************/
function display_scrollStatus(numspc) {
	var spc="";
	if (numspc > 0)
		for (var i=1; i<=numspc; i++)
			spc = spc + "&nbsp;";
	else {
		Display.stringScroll = Display.stringScroll.substring(1, Display.stringScroll.length);
		if (Display.stringScroll.length == 0) {
			if (Display.msgScroll == 1)	Display.stringScroll = Display.stringScrollOriginal;
			else Display.stringScroll = Display.stringScrollMetadata;
			
			document.getElementById("media_name").innerHTML= Display.stringScroll;
			return;
		}
	}
	if (Display.stringScroll.substring(0, 1) == " ") {
		spc = spc + "&nbsp;";
		Display.stringScroll = Display.stringScroll.substring(1, Display.stringScroll.length);
		document.getElementById("media_name").innerHTML= spc + Display.stringScroll;
		Display.stringScroll = " " + Display.stringScroll;
	}
	else document.getElementById("media_name").innerHTML= spc + Display.stringScroll;
	
	numspc--;
	if (numspc<0)
		numspc=0;
	spc = "Display.scrollStatus(" + numspc + ")";
	Display.timeScroll = setTimeout(spc,500);
}


/*******************************************************************************
 * display_hideMediaName - Oculta a apresentacao da string media_name
 *******************************************************************************/
function display_hideMediaName()
{
	document.getElementById("media_name").innerHTML = "";
}


/*******************************************************************************
 * display_hideMediaStatus - Oculta a apresentacao da string media_status
 *******************************************************************************/
function display_hideMediaStatus()
{
	document.getElementById("media_status").innerHTML = "";
}


function display_changeScroll() {
	if(Display.timeScroll)
		clearTimeout(Display.timeScroll);
		
	// Muda de Display.stringScrollOriginal para Display.stringScrollMetadata
	if (Display.msgScroll == 1) {
		if (Display.stringScrollMetadata!="") {
			Display.stringScroll = Display.stringScrollMetadata;
			Display.msgScroll=2;
		}
		else Display.stringScroll = Display.stringScrollOriginal; 
	}
	else if (Display.msgScroll == 2) {
		Display.stringScroll = Display.stringScrollOriginal;
		Display.msgScroll=1;
	}
	Display.timeScroll = setTimeout("Display.startScroll()", 100);
}
